/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.fushi.PPayOrderResponse
 *  fire.pb.main.ConfigManager
 *  net.sf.json.JSONException
 *  net.sf.json.JSONObject
 *  org.apache.log4j.Logger
 */
package fire.pb.callback;

import fire.pb.callback.Encrypter;
import fire.pb.callback.Message;
import fire.pb.callback.ParseUtil;
import fire.pb.fushi.PPayOrderResponse;
import fire.pb.main.ConfigManager;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SocketChannel;
import net.sf.json.JSONException;
import net.sf.json.JSONObject;
import org.apache.log4j.Logger;

public class MessageHandler {
    public static final Logger logger = Logger.getLogger((String)"RECHARGE");

    public static void handleMessage(Message revMsg, SocketChannel sc) {
        try {
            revMsg.readHeader();
        }
        catch (ArrayIndexOutOfBoundsException e) {
            logger.error((Object)("MessageHandler.handleMessage:readHeader异常:" + e));
            e.printStackTrace();
        }
        switch (revMsg.getMessageNum()) {
            case 3: {
                MessageHandler.doPay(revMsg, sc);
                break;
            }
            default: {
                logger.info((Object)("MessageHandler.handleMessage:未定义的消息号=" + revMsg.getMessageNum()));
            }
        }
    }

    private static void doVersion3Pay(Message revMsg, SocketChannel sc, short iVersion) {
        logger.warn((Object)"MessageHandler.doVersion3Pay:版本3的充值回调不做处理!");
    }

    private static void doVersion5Pay(Message revMsg, SocketChannel sc, short iVersion) {
        String strPayData = revMsg.readString();
        String strSign = revMsg.readString();
        logger.info((Object)("MessageHandler.doVersion5Pay:iVersion=" + iVersion + "充值回调处理开始!strPayData=" + strPayData + ",strSign=" + strSign));
        String strGameKey = ConfigManager.getGameKey();
        String strPrepare = strGameKey + iVersion + strPayData;
        String strMySign = Encrypter.MD5(strPrepare);
        if (!strMySign.toLowerCase().equals(strSign.toLowerCase())) {
            logger.error((Object)("MessageHandler.doVersion5Pay:iVersion=" + iVersion + "充值回调签名效验失败!"));
            MessageHandler.sendFailure(sc);
        } else {
            logger.info((Object)("MessageHandler.doVersion5Pay:iVersion=" + iVersion + "充值回调处理开始!签名效验成功."));
            try {
                String cpinfoRoleId;
                String cpinfoSelfChannel;
                JSONObject jsonObject = JSONObject.fromObject((Object)strPayData);
                String strOrderId = jsonObject.getString("OrderId");
                String strChannel = jsonObject.getString("Channel");
                String strPlatformId = jsonObject.getString("PlatformId");
                String strCpInfo = jsonObject.getString("CpInfo");
                int iServerId = jsonObject.getInt("ServerId");
                long lRoleId = jsonObject.getLong("RoleId");
                logger.info((Object)("MessageHandler.doVersion5Pay:OrderId=" + strOrderId + ",Channel=" + strChannel + ",PlatformId=" + strPlatformId + ",ServerId=" + iServerId + ",RoleId=" + lRoleId));
                String decodeCpInfo = ParseUtil.getFromBase64(strCpInfo);
                if (null == decodeCpInfo) {
                    logger.error((Object)("MessageHandler.doVersion5Pay decodeCpInfo=" + decodeCpInfo));
                    MessageHandler.sendFailure(sc);
                    return;
                }
                logger.info((Object)("MessageHandler.doVersion5Pay decodeCpInfo=" + decodeCpInfo));
                String selfchannel = "";
                String[] cpinfos = decodeCpInfo.split("\\|");
                String cpinfoGamesn = "";
                if (strChannel.equals("1SDK")) {
                    if (cpinfos.length < 7) {
                        logger.error((Object)("MessageHandler.doVersion5Pay cpinfos=" + cpinfos.toString() + ",length=" + cpinfos.length));
                        MessageHandler.sendFailure(sc);
                        return;
                    }
                    if (cpinfos.length == 7) {
                        selfchannel = cpinfoSelfChannel = cpinfos[1];
                        cpinfoRoleId = cpinfos[2];
                        cpinfoGamesn = "-1";
                        logger.info((Object)("MessageHandler.doVersion5Pay roleId=" + cpinfoRoleId + ",gamesn=" + cpinfoGamesn + ",selfchannel=" + selfchannel));
                    } else {
                        selfchannel = cpinfoSelfChannel = cpinfos[1];
                        cpinfoRoleId = cpinfos[2];
                        cpinfoGamesn = cpinfos[cpinfos.length - 1];
                        logger.info((Object)("MessageHandler.doVersion5Pay roleId=" + cpinfoRoleId + ",gamesn=" + cpinfoGamesn + ",selfchannel=" + selfchannel));
                    }
                } else {
                    if (cpinfos.length < 5) {
                        logger.error((Object)("MessageHandler.doVersion5Pay cpinfos=" + cpinfos.toString() + ",length=" + cpinfos.length));
                        MessageHandler.sendFailure(sc);
                        return;
                    }
                    if (cpinfos.length == 5) {
                        selfchannel = cpinfoSelfChannel = cpinfos[1];
                        cpinfoRoleId = cpinfos[2];
                        cpinfoGamesn = "-1";
                        logger.info((Object)("MessageHandler.doVersion5Pay roleId=" + cpinfoRoleId + ",gamesn=" + cpinfoGamesn + ",selfchannel=" + selfchannel));
                    } else {
                        selfchannel = cpinfoSelfChannel = cpinfos[1];
                        cpinfoRoleId = cpinfos[2];
                        cpinfoGamesn = cpinfos[cpinfos.length - 1];
                        logger.info((Object)("MessageHandler.doVersion5Pay roleId=" + cpinfoRoleId + ",gamesn=" + cpinfoGamesn + ",selfchannel=" + selfchannel));
                    }
                }
                String selfchannel0 = selfchannel.substring(0, 1);
                String account = strPlatformId + "@@" + strChannel + "@" + selfchannel0;
                logger.info((Object)("MessageHandler.doVersion5Pay account=" + account));
                new PPayOrderResponse(jsonObject, iVersion, iServerId, lRoleId, cpinfoGamesn).submit();
                MessageHandler.sendSuccess(sc, strOrderId);
            }
            catch (JSONException e) {
                MessageHandler.sendFailure(sc);
            }
        }
    }

    private static void doPay(Message revMsg, SocketChannel sc) {
        try {
            short iVersion = revMsg.readShort();
            if (iVersion == 3) {
                MessageHandler.doVersion3Pay(revMsg, sc, iVersion);
            } else if (iVersion == 5) {
                MessageHandler.doVersion5Pay(revMsg, sc, iVersion);
            } else {
                logger.error((Object)("MessageHandler.handleMessage:doPay.version=" + iVersion + ",未接入的处理版本号！"));
            }
        }
        catch (ArrayIndexOutOfBoundsException e) {
            logger.error((Object)("MessageHandler.handleMessage:doPay.处理异常e=" + e));
            MessageHandler.sendFailure(sc);
        }
    }

    private static void sendSuccess(SocketChannel sc, String strOrderId) {
        try {
            Message msgOut = new Message(2);
            msgOut.setMessageNum((short)4);
            msgOut.writeString(strOrderId);
            msgOut.writeShort((short)1);
            ByteBuffer buf = msgOut.toSend();
            sc.write(buf);
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        catch (ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
        }
    }

    private static void sendFailure(SocketChannel sc) {
        try {
            Message msgOut = new Message(2);
            msgOut.setMessageNum((short)4);
            msgOut.writeString("");
            msgOut.writeShort((short)2);
            ByteBuffer buf = msgOut.toSend();
            sc.write(buf);
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        catch (ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
        }
    }
}

